import josx.robotics.*;
import josx.platform.rcx.*;

public class BehaviorDemo implements SensorConstants {

    public static void main(String[] args) {
	Sensor.S1.setTypeAndMode(SENSOR_TYPE_LIGHT, SENSOR_MODE_PCT);
	Sensor.S1.activate();

	Behavior b1 = new DriveForward();
	Behavior b2 = new HitLine();
	Behavior[] bs = {b1, b2};
	Arbitrator a = new Arbitrator(bs);
	a.start();
    }
}

class DriveForward implements Behavior {

    public boolean takeControl() {
	return true;
    }

    public void action() {
	Motor.A.forward();
	Motor.C.forward();
    }

    public void suppress() {
	Motor.A.stop();
	Motor.C.stop();
    }
}

class HitLine implements Behavior {

    public boolean takeControl() {
	return Sensor.S1.readValue() < 38;
    }

    public void action() {
	try {
	    Motor.A.backward();
	    Motor.C.backward();
	    Thread.sleep(300);
	    Motor.C.stop();
	    Thread.sleep(500);
	} catch (InterruptedException e) {
	}
    }

    public void suppress() {
	Motor.A.stop();
	Motor.C.stop();
    }
}
